FilteringTokenFilter (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.analysis, class: FilteringTokenFilter

Package org.apache.lucene.analysis

# Class FilteringTokenFilter

java.lang.Object
org.apache.lucene.util.AttributeSource
org.apache.lucene.analysis.TokenStream
org.apache.lucene.analysis.TokenFilter
org.apache.lucene.analysis.FilteringTokenFilter

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Unwrappable<TokenStream>`

Direct Known Subclasses:
  `StopFilter`

public abstract class FilteringTokenFilter extends TokenFilter
Abstract base class for TokenFilters that may remove tokens. You have to implement `accept()` and return a boolean if the current token should be preserved. `incrementToken()` uses this method to decide if a token should be passed to the caller.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

  `AttributeSource.State`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

  `input`

  ### Fields inherited from class org.apache.lucene.analysis.TokenStream

  `DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FilteringTokenFilter(TokenStream in)`
  Create a new `FilteringTokenFilter`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract boolean`
  `accept()`
  Override this method and return if the current input token should be returned by `incrementToken()`.
  `void`
  `end()`
  This method is called by the consumer after the last token has been consumed, after `TokenStream.incrementToken()` returned `false` (using the new `TokenStream` API).
  `final boolean`
  `incrementToken()`
  Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token.
  `void`
  `reset()`
  This method is called by a consumer before it begins consumption using `TokenStream.incrementToken()`.

  ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

  `close, unwrap`

  ### Methods inherited from class org.apache.lucene.util.AttributeSource

  `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### FilteringTokenFilter

    public FilteringTokenFilter(TokenStream in)
    Create a new `FilteringTokenFilter`.
    Parameters:
      `in` - the `TokenStream` to consume

- ## Method Details

  - ### accept

    protected abstract boolean accept() throws IOException
    Override this method and return if the current input token should be returned by `incrementToken()`.
    Throws:
      `IOException`

  - ### incrementToken

    public final boolean incrementToken() throws IOException
    Description copied from class: `TokenStream`
    Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token. Implementing classes must implement this method and update the appropriate `AttributeImpl`s with the attributes of the next token.

    The producer must make no assumptions about the attributes after the method has been returned: the caller may arbitrarily change it. If the producer needs to preserve the state for subsequent calls, it can use `AttributeSource.captureState()` to create a copy of the current attribute state.

    This method is called for every token of a document, so an efficient implementation is crucial for good performance. To avoid calls to `AttributeSource.addAttribute(Class)` and `AttributeSource.getAttribute(Class)`, references to all `AttributeImpl`s that this stream uses should be retrieved during instantiation.

    To ensure that filters and consumers know which attributes are available, the attributes must be added during instantiation. Filters and consumers are not required to check for availability of attributes in `TokenStream.incrementToken()`.

    Specified by:
      `incrementToken` in class `TokenStream`
    Returns:
      false for end of stream; true otherwise
    Throws:
      `IOException`

  - ### reset

    public void reset() throws IOException
    Description copied from class: `TokenFilter`
    This method is called by a consumer before it begins consumption using `TokenStream.incrementToken()`.

    Resets this stream to a clean state. Stateful implementations must implement this method so that they can be reused, just as if they had been created fresh.

    If you override this method, always call `super.reset()`, otherwise some internal state will not be correctly reset (e.g., `Tokenizer` will throw `IllegalStateException` on further usage).

    NOTE: The default implementation chains the call to the input TokenStream, so be sure to call `super.reset()` when overriding this method.

    Overrides:
      `reset` in class `TokenFilter`
    Throws:
      `IOException`

  - ### end

    public void end() throws IOException
    Description copied from class: `TokenFilter`
    This method is called by the consumer after the last token has been consumed, after `TokenStream.incrementToken()` returned `false` (using the new `TokenStream` API). Streams implementing the old API should upgrade to use this feature.

    This method can be used to perform any end-of-stream operations, such as setting the final offset of a stream. The final offset of a stream might differ from the offset of the last token eg in case one or more whitespaces followed after the last token, but a WhitespaceTokenizer was used.

    Additionally any skipped positions (such as those removed by a stopfilter) can be applied to the position increment, or any adjustment of other attributes where the end-of-stream value may be important.

    If you override this method, always call `super.end()`.

    NOTE: The default implementation chains the call to the input TokenStream, so be sure to call `super.end()` first when overriding this method.

    Overrides:
      `end` in class `TokenFilter`
    Throws:
      `IOException` - If an I/O error occurs